(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
/**
 * lodash 3.0.0 (Custom Build) <https://lodash.com/>
 * Build: `lodash modern modularize exports="npm" -o ./`
 * Copyright 2012-2015 The Dojo Foundation <http://dojofoundation.org/>
 * Based on Underscore.js 1.7.0 <http://underscorejs.org/LICENSE>
 * Copyright 2009-2015 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 * Available under MIT license <https://lodash.com/license>
 */

/** Used to match template delimiters. */
var reInterpolate = /<%=([\s\S]+?)%>/g;

module.exports = reInterpolate;

},{}],2:[function(require,module,exports){
(function (global){
/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
var reInterpolate = require('lodash._reinterpolate'),
    templateSettings = require('lodash.templatesettings');

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0,
    MAX_SAFE_INTEGER = 9007199254740991;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    symbolTag = '[object Symbol]';

/** Used to match empty string literals in compiled template source. */
var reEmptyStringLeading = /\b__p \+= '';/g,
    reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
    reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

/**
 * Used to match
 * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).
 */
var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/** Used to ensure capturing order of template delimiters. */
var reNoMatch = /($^)/;

/** Used to match unescaped characters in compiled string literals. */
var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

/** Used to escape characters for inclusion in compiled string literals. */
var stringEscapes = {
  '\\': '\\',
  "'": "'",
  '\n': 'n',
  '\r': 'r',
  '\u2028': 'u2028',
  '\u2029': 'u2029'
};

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array ? array.length : 0,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

/**
 * The base implementation of `_.values` and `_.valuesIn` which creates an
 * array of `object` property values corresponding to the property names
 * of `props`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array} props The property names to get values for.
 * @returns {Object} Returns the array of property values.
 */
function baseValues(object, props) {
  return arrayMap(props, function(key) {
    return object[key];
  });
}

/**
 * Used by `_.template` to escape characters for inclusion in compiled string literals.
 *
 * @private
 * @param {string} chr The matched character to escape.
 * @returns {string} Returns the escaped character.
 */
function escapeStringChar(chr) {
  return '\\' + stringEscapes[chr];
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Built-in value references. */
var Symbol = root.Symbol,
    propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object),
    nativeMax = Math.max;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  // Safari 9 makes `arguments.length` enumerable in strict mode.
  var result = (isArray(value) || isArguments(value))
    ? baseTimes(value.length, String)
    : [];

  var length = result.length,
      skipIndexes = !!length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (key == 'length' || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}

/**
 * Used by `_.defaults` to customize its `_.assignIn` use.
 *
 * @private
 * @param {*} objValue The destination value.
 * @param {*} srcValue The source value.
 * @param {string} key The key of the property to assign.
 * @param {Object} object The parent object of `objValue`.
 * @returns {*} Returns the value to assign.
 */
function assignInDefaults(objValue, srcValue, key, object) {
  if (objValue === undefined ||
      (eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key))) {
    return srcValue;
  }
  return objValue;
}

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    object[key] = value;
  }
}

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn(object) {
  if (!isObject(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = array;
    return apply(func, this, otherArgs);
  };
}

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject(source, props, object, customizer) {
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    assignValue(object, key, newValue === undefined ? source[key] : newValue);
  }
  return object;
}

/**
 * Creates a function like `_.assign`.
 *
 * @private
 * @param {Function} assigner The function to assign values.
 * @returns {Function} Returns the new assigner function.
 */
function createAssigner(assigner) {
  return baseRest(function(object, sources) {
    var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;

    customizer = (assigner.length > 3 && typeof customizer == 'function')
      ? (length--, customizer)
      : undefined;

    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? undefined : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length &&
    (typeof value == 'number' || reIsUint.test(value)) &&
    (value > -1 && value % 1 == 0 && value < length);
}

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq(object[index], value);
  }
  return false;
}

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
function isArguments(value) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') &&
    (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
}

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
  return isObjectLike(value) && isArrayLike(value);
}

/**
 * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
 * `SyntaxError`, `TypeError`, or `URIError` object.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
 * @example
 *
 * _.isError(new Error);
 * // => true
 *
 * _.isError(Error);
 * // => false
 */
function isError(value) {
  if (!isObjectLike(value)) {
    return false;
  }
  return (objectToString.call(value) == errorTag) ||
    (typeof value.message == 'string' && typeof value.name == 'string');
}

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

/**
 * This method is like `_.assignIn` except that it accepts `customizer`
 * which is invoked to produce the assigned values. If `customizer` returns
 * `undefined`, assignment is handled by the method instead. The `customizer`
 * is invoked with five arguments: (objValue, srcValue, key, object, source).
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @alias extendWith
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} sources The source objects.
 * @param {Function} [customizer] The function to customize assigned values.
 * @returns {Object} Returns `object`.
 * @see _.assignWith
 * @example
 *
 * function customizer(objValue, srcValue) {
 *   return _.isUndefined(objValue) ? srcValue : objValue;
 * }
 *
 * var defaults = _.partialRight(_.assignInWith, customizer);
 *
 * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
 * // => { 'a': 1, 'b': 2 }
 */
var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
  copyObject(source, keysIn(source), object, customizer);
});

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

/**
 * Creates a compiled template function that can interpolate data properties
 * in "interpolate" delimiters, HTML-escape interpolated data properties in
 * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
 * properties may be accessed as free variables in the template. If a setting
 * object is given, it takes precedence over `_.templateSettings` values.
 *
 * **Note:** In the development build `_.template` utilizes
 * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
 * for easier debugging.
 *
 * For more information on precompiling templates see
 * [lodash's custom builds documentation](https://lodash.com/custom-builds).
 *
 * For more information on Chrome extension sandboxes see
 * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category String
 * @param {string} [string=''] The template string.
 * @param {Object} [options={}] The options object.
 * @param {RegExp} [options.escape=_.templateSettings.escape]
 *  The HTML "escape" delimiter.
 * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]
 *  The "evaluate" delimiter.
 * @param {Object} [options.imports=_.templateSettings.imports]
 *  An object to import into the template as free variables.
 * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]
 *  The "interpolate" delimiter.
 * @param {string} [options.sourceURL='templateSources[n]']
 *  The sourceURL of the compiled template.
 * @param {string} [options.variable='obj']
 *  The data object variable name.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
 * @returns {Function} Returns the compiled template function.
 * @example
 *
 * // Use the "interpolate" delimiter to create a compiled template.
 * var compiled = _.template('hello <%= user %>!');
 * compiled({ 'user': 'fred' });
 * // => 'hello fred!'
 *
 * // Use the HTML "escape" delimiter to escape data property values.
 * var compiled = _.template('<b><%- value %></b>');
 * compiled({ 'value': '<script>' });
 * // => '<b>&lt;script&gt;</b>'
 *
 * // Use the "evaluate" delimiter to execute JavaScript and generate HTML.
 * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
 * compiled({ 'users': ['fred', 'barney'] });
 * // => '<li>fred</li><li>barney</li>'
 *
 * // Use the internal `print` function in "evaluate" delimiters.
 * var compiled = _.template('<% print("hello " + user); %>!');
 * compiled({ 'user': 'barney' });
 * // => 'hello barney!'
 *
 * // Use the ES delimiter as an alternative to the default "interpolate" delimiter.
 * var compiled = _.template('hello ${ user }!');
 * compiled({ 'user': 'pebbles' });
 * // => 'hello pebbles!'
 *
 * // Use backslashes to treat delimiters as plain text.
 * var compiled = _.template('<%= "\\<%- value %\\>" %>');
 * compiled({ 'value': 'ignored' });
 * // => '<%- value %>'
 *
 * // Use the `imports` option to import `jQuery` as `jq`.
 * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
 * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
 * compiled({ 'users': ['fred', 'barney'] });
 * // => '<li>fred</li><li>barney</li>'
 *
 * // Use the `sourceURL` option to specify a custom sourceURL for the template.
 * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
 * compiled(data);
 * // => Find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector.
 *
 * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.
 * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
 * compiled.source;
 * // => function(data) {
 * //   var __t, __p = '';
 * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
 * //   return __p;
 * // }
 *
 * // Use custom template delimiters.
 * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
 * var compiled = _.template('hello {{ user }}!');
 * compiled({ 'user': 'mustache' });
 * // => 'hello mustache!'
 *
 * // Use the `source` property to inline compiled templates for meaningful
 * // line numbers in error messages and stack traces.
 * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\
 *   var JST = {\
 *     "main": ' + _.template(mainText).source + '\
 *   };\
 * ');
 */
function template(string, options, guard) {
  // Based on John Resig's `tmpl` implementation
  // (http://ejohn.org/blog/javascript-micro-templating/)
  // and Laura Doktorova's doT.js (https://github.com/olado/doT).
  var settings = templateSettings.imports._.templateSettings || templateSettings;

  if (guard && isIterateeCall(string, options, guard)) {
    options = undefined;
  }
  string = toString(string);
  options = assignInWith({}, options, settings, assignInDefaults);

  var imports = assignInWith({}, options.imports, settings.imports, assignInDefaults),
      importsKeys = keys(imports),
      importsValues = baseValues(imports, importsKeys);

  var isEscaping,
      isEvaluating,
      index = 0,
      interpolate = options.interpolate || reNoMatch,
      source = "__p += '";

  // Compile the regexp to match each delimiter.
  var reDelimiters = RegExp(
    (options.escape || reNoMatch).source + '|' +
    interpolate.source + '|' +
    (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
    (options.evaluate || reNoMatch).source + '|$'
  , 'g');

  // Use a sourceURL for easier debugging.
  var sourceURL = 'sourceURL' in options ? '//# sourceURL=' + options.sourceURL + '\n' : '';

  string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
    interpolateValue || (interpolateValue = esTemplateValue);

    // Escape characters that can't be included in string literals.
    source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);

    // Replace delimiters with snippets.
    if (escapeValue) {
      isEscaping = true;
      source += "' +\n__e(" + escapeValue + ") +\n'";
    }
    if (evaluateValue) {
      isEvaluating = true;
      source += "';\n" + evaluateValue + ";\n__p += '";
    }
    if (interpolateValue) {
      source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
    }
    index = offset + match.length;

    // The JS engine embedded in Adobe products needs `match` returned in
    // order to produce the correct `offset` value.
    return match;
  });

  source += "';\n";

  // If `variable` is not specified wrap a with-statement around the generated
  // code to add the data object to the top of the scope chain.
  var variable = options.variable;
  if (!variable) {
    source = 'with (obj) {\n' + source + '\n}\n';
  }
  // Cleanup code by stripping empty strings.
  source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
    .replace(reEmptyStringMiddle, '$1')
    .replace(reEmptyStringTrailing, '$1;');

  // Frame code as the function body.
  source = 'function(' + (variable || 'obj') + ') {\n' +
    (variable
      ? ''
      : 'obj || (obj = {});\n'
    ) +
    "var __t, __p = ''" +
    (isEscaping
       ? ', __e = _.escape'
       : ''
    ) +
    (isEvaluating
      ? ', __j = Array.prototype.join;\n' +
        "function print() { __p += __j.call(arguments, '') }\n"
      : ';\n'
    ) +
    source +
    'return __p\n}';

  var result = attempt(function() {
    return Function(importsKeys, sourceURL + 'return ' + source)
      .apply(undefined, importsValues);
  });

  // Provide the compiled function's source by its `toString` method or
  // the `source` property as a convenience for inlining compiled templates.
  result.source = source;
  if (isError(result)) {
    throw result;
  }
  return result;
}

/**
 * Attempts to invoke `func`, returning either the result or the caught error
 * object. Any additional arguments are provided to `func` when it's invoked.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Util
 * @param {Function} func The function to attempt.
 * @param {...*} [args] The arguments to invoke `func` with.
 * @returns {*} Returns the `func` result or error object.
 * @example
 *
 * // Avoid throwing errors for invalid selectors.
 * var elements = _.attempt(function(selector) {
 *   return document.querySelectorAll(selector);
 * }, '>_>');
 *
 * if (_.isError(elements)) {
 *   elements = [];
 * }
 */
var attempt = baseRest(function(func, args) {
  try {
    return apply(func, undefined, args);
  } catch (e) {
    return isError(e) ? e : new Error(e);
  }
});

module.exports = template;

}).call(this,typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"lodash._reinterpolate":1,"lodash.templatesettings":3}],3:[function(require,module,exports){
(function (global){
/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
var reInterpolate = require('lodash._reinterpolate');

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used to match HTML entities and HTML characters. */
var reUnescapedHtml = /[&<>"'`]/g,
    reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

/** Used to match template delimiters. */
var reEscape = /<%-([\s\S]+?)%>/g,
    reEvaluate = /<%([\s\S]+?)%>/g;

/** Used to map characters to HTML entities. */
var htmlEscapes = {
  '&': '&amp;',
  '<': '&lt;',
  '>': '&gt;',
  '"': '&quot;',
  "'": '&#39;',
  '`': '&#96;'
};

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/**
 * The base implementation of `_.propertyOf` without support for deep paths.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyOf(object) {
  return function(key) {
    return object == null ? undefined : object[key];
  };
}

/**
 * Used by `_.escape` to convert characters to HTML entities.
 *
 * @private
 * @param {string} chr The matched character to escape.
 * @returns {string} Returns the escaped character.
 */
var escapeHtmlChar = basePropertyOf(htmlEscapes);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Built-in value references. */
var Symbol = root.Symbol;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * By default, the template delimiters used by lodash are like those in
 * embedded Ruby (ERB). Change the following template settings to use
 * alternative delimiters.
 *
 * @static
 * @memberOf _
 * @type {Object}
 */
var templateSettings = {

  /**
   * Used to detect `data` property values to be HTML-escaped.
   *
   * @memberOf _.templateSettings
   * @type {RegExp}
   */
  'escape': reEscape,

  /**
   * Used to detect code to be evaluated.
   *
   * @memberOf _.templateSettings
   * @type {RegExp}
   */
  'evaluate': reEvaluate,

  /**
   * Used to detect `data` property values to inject.
   *
   * @memberOf _.templateSettings
   * @type {RegExp}
   */
  'interpolate': reInterpolate,

  /**
   * Used to reference the data object in the template text.
   *
   * @memberOf _.templateSettings
   * @type {string}
   */
  'variable': '',

  /**
   * Used to import variables into the compiled template.
   *
   * @memberOf _.templateSettings
   * @type {Object}
   */
  'imports': {

    /**
     * A reference to the `lodash` function.
     *
     * @memberOf _.templateSettings.imports
     * @type {Function}
     */
    '_': { 'escape': escape }
  }
};

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

/**
 * Converts the characters "&", "<", ">", '"', "'", and "\`" in `string` to
 * their corresponding HTML entities.
 *
 * **Note:** No other characters are escaped. To escape additional
 * characters use a third-party library like [_he_](https://mths.be/he).
 *
 * Though the ">" character is escaped for symmetry, characters like
 * ">" and "/" don't need escaping in HTML and have no special meaning
 * unless they're part of a tag or unquoted attribute value. See
 * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
 * (under "semi-related fun fact") for more details.
 *
 * Backticks are escaped because in IE < 9, they can break out of
 * attribute values or HTML comments. See [#59](https://html5sec.org/#59),
 * [#102](https://html5sec.org/#102), [#108](https://html5sec.org/#108), and
 * [#133](https://html5sec.org/#133) of the
 * [HTML5 Security Cheatsheet](https://html5sec.org/) for more details.
 *
 * When working with HTML you should always
 * [quote attribute values](http://wonko.com/post/html-escaping) to reduce
 * XSS vectors.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category String
 * @param {string} [string=''] The string to escape.
 * @returns {string} Returns the escaped string.
 * @example
 *
 * _.escape('fred, barney, & pebbles');
 * // => 'fred, barney, &amp; pebbles'
 */
function escape(string) {
  string = toString(string);
  return (string && reHasUnescapedHtml.test(string))
    ? string.replace(reUnescapedHtml, escapeHtmlChar)
    : string;
}

module.exports = templateSettings;

}).call(this,typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"lodash._reinterpolate":1}],4:[function(require,module,exports){

/*
 * Application attachments class
 * Alexander Konov
 */
'use strict';
var Attachments, DI, Field, merge,
  hasProp = {}.hasOwnProperty;

DI = require('./di/DI');

Field = require('./field/Field');

merge = require('./utils/merge');

Attachments = (function() {
  Attachments.prototype.defaultOptions = {
    dialog: require('./utils/Dialog'),
    animationSpeed: 500,
    url: {
      list: null,
      upload: null,
      "delete": null,
      find: null
    },
    view: {
      field: require('./views/field/field'),
      selector: require('./views/field/selector'),
      selectorFile: require('./views/field/selectorFile')
    },
    valueDelimiter: ', ',
    extensions: null,
    maxSelected: null,
    maxUploadSize: null,
    listLimit: 25,
    schemes: {
      requests: {
        find: {
          id: 'id',
          name: 'name',
          extension: 'extension'
        },
        list: {
          id: 'id',
          name: 'name',
          extension: 'extension',
          offset: 'offset',
          limit: 'limit'
        },
        upload: {
          file: 'file'
        },
        "delete": {
          id: 'id'
        }
      },
      responses: {
        file: {
          id: 'id',
          name: 'name',
          extension: 'extension',
          size: 'size',
          url: 'url',
          preview_url: 'preview_url',
          created_at: 'created_at',
          updated_at: 'updated_at'
        },
        list: {
          total: 'total',
          files: 'files'
        },
        upload: {
          files: 'files'
        },
        find: {
          files: 'files'
        }
      }
    },
    translate: null
  };


  /*
   * Constructor
   * @param jQuery $ - jQuery instance
   * @param DOM el - an element which is attached to attachment field
   * @param {} options - object with options which configure Server object
   *  see description options in docs
   * @param DOM rootElement - element for storage rendered views
   */

  function Attachments($, el, options, rootElement) {
    var name, ref, source;
    this._$el = $(el);
    this.options = merge(this.defaultOptions, options);
    ref = this.options.view;
    for (name in ref) {
      if (!hasProp.call(ref, name)) continue;
      source = ref[name];
      if (source.selector !== void 0) {
        this.options.view[name] = $(source.selector).html();
      }
    }
    if (!this.options.translate) {
      this.options.translate = {};
    }
    this._di = new DI();
    this._di.set('$', $).set('lodash.template', require('lodash.template')).set('models.File', require('./models/File')).set('collections.FilesCollection', require('./collections/FilesCollection')).set('field.Selector', require('./field/Selector')).set('server.Server', require('./server/Server')).set('server.schemes.responses.File', require('./server/schemes/responses/File')).set('server.schemes.responses.Find', require('./server/schemes/responses/Find')).set('server.schemes.responses.List', require('./server/schemes/responses/List')).set('server.schemes.responses.Upload', require('./server/schemes/responses/Upload')).set('server.schemes.requests.Find', require('./server/schemes/requests/Find')).set('server.schemes.requests.List', require('./server/schemes/requests/List')).set('server.schemes.requests.Upload', require('./server/schemes/requests/Upload')).set('server.schemes.requests.Delete', require('./server/schemes/requests/Delete')).set('events.Events', require('./events/Events')).set('utils.DataMap', require('./utils/DataMap')).set('utils.Translate', require('./utils/Translate')).set('utils.Template', require('./utils/Template')).set('utils.uniqueID', require('./utils/uniqueID')).setInstance('collections.FilesCollection', [this._di]).setInstance('events.Events', [this._di]).setInstance('server.Server', [
      this._di, {
        schemes: this.options.schemes
      }
    ]).setInstance('utils.Translate', [this.options.translate]).setInstance('utils.Template', [this._di]);
    this._field = new Field(this._di, el, this.options, rootElement);
    this._bind();
  }


  /*
   * Bind to Field events
   * @return void
   */

  Attachments.prototype._bind = function() {
    var events;
    events = this._di.getInstance('events.Events');
    events.on(this._field, 'change', (function(_this) {
      return function(e, files) {
        return events.trigger(_this._$el, 'change', [_this._filesToFields(files)]);
      };
    })(this));
  };


  /*
   * Get all files which loaded from server on current moment
   * @return File[]
   */

  Attachments.prototype.allReceivedFiles = function() {
    return this._filesToFields(this._field.allReceivedFiles());
  };


  /*
   * Get all selected files
   * @return File[]
   */

  Attachments.prototype.selectedFiles = function() {
    return this._filesToFields(this._field.getSelectedFiles());
  };


  /*
   * Select file by id
   * @param string in - file id for attachment
   * @return void
   */

  Attachments.prototype.selectFile = function(id) {
    this._field.setSelectedFiles([id], true);
  };


  /*
   * Deselect file by id
   * @param string id - id file to deselect
   * @return void
   */

  Attachments.prototype.deSelectFile = function(id) {
    this._field.deSelectFile(id);
  };


  /*
   * Get unique id for current field
   * @return string
   */

  Attachments.prototype.getUID = function() {
    return this._field.getUID();
  };


  /*
   * Convert array with File objects to array with fields objects
   * @param File[] files - files for convert
   * @return Object[]
   */

  Attachments.prototype._filesToFields = function(files) {
    var i, j, ref, results;
    results = [];
    for (i = j = 0, ref = files.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
      results.push(files[i].getFields());
    }
    return results;
  };

  return Attachments;

})();

module.exports = Attachments;


},{"./collections/FilesCollection":5,"./di/DI":6,"./events/Events":7,"./field/Field":8,"./field/Selector":9,"./models/File":11,"./server/Server":12,"./server/schemes/requests/Delete":14,"./server/schemes/requests/Find":15,"./server/schemes/requests/List":16,"./server/schemes/requests/Upload":17,"./server/schemes/responses/File":18,"./server/schemes/responses/Find":19,"./server/schemes/responses/List":20,"./server/schemes/responses/Upload":21,"./utils/DataMap":22,"./utils/Dialog":23,"./utils/Template":24,"./utils/Translate":25,"./utils/merge":26,"./utils/uniqueID":27,"./views/field/field":28,"./views/field/selector":29,"./views/field/selectorFile":30,"lodash.template":2}],5:[function(require,module,exports){

/*
 * Collection for files (file model)
 * Alexander Konov
 */
'use strict';
var FilesCollection;

FilesCollection = (function() {

  /*
   * Constructor
   * @param DI di - dependencies object
   */
  function FilesCollection(di) {
    di.resolve(['utils.DataMap', 'models.File']);
    this._di = di;
    this._map = di.createObject('utils.DataMap');
    return;
  }


  /*
   * Add files to collection from array
   * @param File[]|Object[] files - array with files or array objects with fields of file
   */

  FilesCollection.prototype.addFiles = function(files) {
    var file, i, len;
    if (!files || !files.length) {
      return;
    }
    for (i = 0, len = files.length; i < len; i++) {
      file = files[i];
      this.addFile(file);
    }
  };


  /*
   * Add file to collection
   * @param File|Object file - adding file or object with fields of file
   */

  FilesCollection.prototype.addFile = function(file) {
    if (!(file instanceof this._di.get('models.File'))) {
      file = this._objectToFile(file);
    }
    if (!file) {
      return false;
    }
    this._map.add(file.getField('id'), file);
  };


  /*
   * Check exists file in collection by id
   * @param int|string id - file id
   * @return bool
   */

  FilesCollection.prototype.has = function(id) {
    return this._map.has(id);
  };


  /*
   * Get file from collection
   * @param string|int id - file id
   * @return File|null
   */

  FilesCollection.prototype.getFile = function(id) {
    return this._map.get(id);
  };


  /*
   * Get all files from collection
   * @return File[]
   */

  FilesCollection.prototype.getFiles = function() {
    return this._map.toArray();
  };


  /*
   * Remove file from collection
   * @param string|int id - file id
   */

  FilesCollection.prototype.removeFile = function(id) {
    this._map.remove(id);
  };


  /*
   * Remove all files in collection
   */

  FilesCollection.prototype.clear = function() {
    this._map.clear();
  };


  /*
   * Number of files in collection
   * @return int
   */

  FilesCollection.prototype.length = function() {
    return this._map.length();
  };


  /*
   * Create File object from objects with file fields
   * @return File
   */

  FilesCollection.prototype._objectToFile = function(fields) {
    return this._di.createObject('models.File', [fields]);
  };

  return FilesCollection;

})();

module.exports = FilesCollection;


},{}],6:[function(require,module,exports){

/*
 * Dependency manager
 * Alexander Konov
 */
'use strict';
var DI;

DI = (function() {

  /*
   * Constructor
   */
  function DI() {
    this._functions = {};
    this._instancesData = {};
    this._instances = {};
  }


  /*
   * Set dependency
   * @param string key - key for dependency
   * @param constructor|callable func - dependency
   */

  DI.prototype.set = function(key, func) {
    this._functions[key] = func;
    this.deleteInstance(key);
    return this;
  };


  /*
   * Get dependency by key
   * @param string key - key for dependency
   * @return constructor|callable
   * @throw Error - error if dependency is not set
   */

  DI.prototype.get = function(key) {
    if (!this._functions[key]) {
      throw new Error('Dependency with key ' + key + ' is not resolve.');
    }
    return this._functions[key];
  };


  /*
   * Delete dependency by key
   * @param string key - key for dependency
   */

  DI.prototype["delete"] = function(key) {
    if (this._functions[key]) {
      delete this._functions[key];
    }
    return this;
  };


  /*
   * Create object on base dependency
   * @param string key - key for dependency
   * @param mixed[] args - arguments for dependency constructor
   * @return constructor|callable
   * @throw Error - error if dependency is not set or dependency is not constructor
   */

  DI.prototype.createObject = function(key, args) {
    var func;
    args = args || [];
    func = this.get(key);
    return (function(func, args, ctor) {
      ctor.prototype = func.prototype;
      var child = new ctor, result = func.apply(child, args);
      return Object(result) === result ? result : child;
    })(func, args, function(){});
  };


  /*
   * Set instance on base dependency
   * @param string key - key for dependency
   * @param mixed[] args - arguments for dependency constructor
   * @return this
   */

  DI.prototype.setInstance = function(key, args) {
    this._instancesData[key] = args || null;
    return this;
  };


  /*
   * Get dependency instance by key
   * @param string key - key for dependency
   * @return Object
   * @throw Error - error if dependency or dependency instance is not set
   */

  DI.prototype.getInstance = function(key) {
    if (this._instances[key]) {
      return this._instances[key];
    }
    if (this._instancesData[key] === void 0) {
      throw new Error('Instance data for dependency with key ' + key + ' is not set.');
    }
    this._instances[key] = this.createObject(key, this._instancesData[key]);
    return this._instances[key];
  };


  /*
   * Delete dependency instance by key
   * @param string key - key for dependency
   */

  DI.prototype.deleteInstance = function(key) {
    if (this._instancesData[key]) {
      delete this._instancesData[key];
    }
    if (this._instances[key]) {
      delete this._instances[key];
    }
    return this;
  };


  /*
   * Check resolved required dependencies
   * @param string|string[] dependencyKeys - keys of required dependencies
   * @param string|string[] instanceKeys = [] - keys of required instances
   * @throw Error - error if dependencies is not resolve
   */

  DI.prototype.resolve = function(dependencyKeys, instanceKeys) {
    var i, j, key, len, len1, resolved;
    if (!(dependencyKeys instanceof Array)) {
      dependencyKeys = [dependencyKeys];
    }
    if (!instanceKeys) {
      instanceKeys = [];
    }
    if (!(instanceKeys instanceof Array)) {
      instanceKeys = [instanceKeys];
    }
    resolved = true;
    for (i = 0, len = dependencyKeys.length; i < len; i++) {
      key = dependencyKeys[i];
      if (!this._functions[key]) {
        resolved = false;
        break;
      }
    }
    if (resolved) {
      for (j = 0, len1 = instanceKeys.length; j < len1; j++) {
        key = instanceKeys[j];
        if (this._instancesData[key] === void 0) {
          resolved = false;
          break;
        }
      }
    }
    if (!resolved) {
      throw new Error('Unresolved dependencies.');
    }
    return this;
  };

  return DI;

})();

module.exports = DI;


},{}],7:[function(require,module,exports){

/*
 * Events
 * Alexander Konov
 */
'use strict';
var Events;

Events = (function() {

  /*
   * namespace for jquery events
   */
  Events.namespace = 'attachments';


  /*
   * Constructor
   * @param DI di - dependencies object
   */

  function Events(di) {
    di.resolve(['$']);
    this._$ = di.get('$');
  }


  /*
   * Attach an event handler for object
   * @param Object object - object for event
   * @param string name - event name
   * @param callback handler - event handler
   * @param mixed{} options - additional options
   *         Options:
   *           selector - a selector string to filter the descendants of the selected elements that trigger the event
   */

  Events.prototype.on = function(object, name, handler, options) {
    var $object, selector;
    options = options || {};
    if (object instanceof this._$) {
      $object = object;
    } else {
      $object = this._$(object);
    }
    selector = options.selector || null;
    $object.on(name + '.' + this.constructor.namespace, selector, handler);
  };


  /*
   * Trigger event for object
   * @param Object object - object for event
   * @param string name - event name
   * @param mixed[] data - data for event handler
   */

  Events.prototype.trigger = function(object, name, data) {
    return this._$(object).trigger(name + '.' + this.constructor.namespace, data);
  };

  return Events;

})();

module.exports = Events;


},{}],8:[function(require,module,exports){

/*
 * Class for attachments field
 * Alexander Konov
 */
'use strict';
var Field,
  hasProp = {}.hasOwnProperty;

Field = (function() {

  /*
   * Constructor
   * @param DI di - dependency injection object
   * @param DOM el - an element which is attached to attachment field
   * @param {} options - object with options which configure Server object
   *  see description options in docs
   * @param DOM rootElement - element for storage rendered views
   */
  function Field(di, el, options, rootElement) {
    di.resolve(['$', 'collections.FilesCollection', 'server.Server', 'utils.Translate', 'utils.Template', 'field.Selector', 'events.Events'], ['collections.FilesCollection', 'server.Server', 'utils.Translate', 'utils.Template', 'events.Events']);
    this._uid = di.get('utils.uniqueID')();
    this._$ = di.get('$');
    this._filesCollection = di.getInstance('collections.FilesCollection');
    this._server = di.getInstance('server.Server');
    this._translate = di.getInstance('utils.Translate');
    this._template = di.getInstance('utils.Template');
    this._selector = di.createObject('field.Selector', [di, rootElement, options, this._uid]);
    this._events = di.getInstance('events.Events');
    this._options = options;
    this._$el = this._$(el);
    this._$rootElement = this._$(rootElement);
    this._selected = {};
    this._init();
  }


  /*
   * Get all files which loaded from server on now moment
   * @return File[]
   */

  Field.prototype.allReceivedFiles = function() {
    return this._filesCollection.getFiles();
  };


  /*
   * Set selected files for attachment
   * @param string[]|string filesId - id files for attachments
   * @param bool noClear - switch for clear/complete selected files before set
   * @return void
   */

  Field.prototype.setSelectedFiles = function(filesId, noClear) {
    var i, id, len;
    if (!noClear) {
      this._selected = {};
    }
    if (!(filesId instanceof Array)) {
      filesId = [filesId];
    }
    for (i = 0, len = filesId.length; i < len; i++) {
      id = filesId[i];
      if (this._filesCollection.has(id)) {
        this._selected[id] = true;
      }
    }
    this._render();
  };


  /*
   * Get all selected files
   * @return File[]
   */

  Field.prototype.getSelectedFiles = function() {
    var file, id, ref, result;
    result = [];
    ref = this._selected;
    for (id in ref) {
      if (!hasProp.call(ref, id)) continue;
      file = this._filesCollection.getFile(id);
      if (file) {
        result.push(file);
      }
    }
    return result;
  };


  /*
   * Deselect file by id
   * @param string id - id file to deselect
   * @return void
   */

  Field.prototype.deSelectFile = function(id) {
    var $file;
    if (!(this._selected && this._selected[id])) {
      return;
    }
    delete this._selected[id];
    $file = this._$view.find('[jq-attachments-selected-files-file][data-id="' + id + '"]');
    $file.hide(this._options.animationSpeed, (function(_this) {
      return function() {
        if (_this._getSelectedFilesID().length) {
          $file.remove();
          _this._setInputVal(_this._getSelectedFilesID());
        } else {
          _this._render();
        }
        return _this._triggerChange();
      };
    })(this));
  };


  /*
   * Get unique id for current field
   * @return string
   */

  Field.prototype.getUID = function() {
    return this._uid;
  };


  /*
   * Initialize field
   * @return void
   */

  Field.prototype._init = function() {
    var attached;
    this._bindToSelector();
    this._$el.hide();
    attached = this._options.attached || [];
    if (attached.length) {
      this._filesCollection.addFiles(attached);
    }
    this._loadSelected();
  };


  /*
   * Load selected files which exists in @_el value
   * @return void
   */

  Field.prototype._loadSelected = function() {
    var filesId, values;
    values = (this._$el.val().split(this._options.valueDelimiter)).map(function(fileID) {
      return fileID.trim();
    });
    if (!values.length) {
      this._render();
      return;
    }
    filesId = values.filter((function(_this) {
      return function(id) {
        return !_this._filesCollection.has(id);
      };
    })(this));
    this._server.find(this._options.url.find, {
      id: filesId
    }, (function(_this) {
      return function(data) {
        var file, i, len, ref;
        _this._filesCollection.addFiles(data.files);
        ref = data.files;
        for (i = 0, len = ref.length; i < len; i++) {
          file = ref[i];
          _this.setSelectedFiles(file.id, true);
        }
        return _this._render();
      };
    })(this));
  };


  /*
   * Get selected file id
   * @return string[]
   */

  Field.prototype._getSelectedFilesID = function() {
    var id, ref, result;
    result = [];
    ref = this._selected;
    for (id in ref) {
      if (!hasProp.call(ref, id)) continue;
      result.push(id);
    }
    return result;
  };


  /*
   * Render view
   * @return void
   */

  Field.prototype._render = function() {
    var html;
    if (this._$view !== void 0) {
      this._$view.remove();
    }
    html = this._template.render(this._options.view.field, {
      files: this.getSelectedFiles()
    });
    this._$view = this._$(html);
    this._setInputVal(this._getSelectedFilesID());
    this._$el.after(this._$view);
    this._bind(this._$view);
  };


  /*
   * Bind events on instead elements in field
   * @return void
   */

  Field.prototype._bind = function($el) {
    this._events.on($el, 'click', (function(_this) {
      return function(e) {
        _this._selector.open(_this._getSelectedFilesID());
        e.preventDefault();
        return false;
      };
    })(this), {
      selector: '[jq-attachments-add]'
    });
    this._events.on($el, 'click', (function(_this) {
      return function(e) {
        var $file;
        if (_this._options.dialog.confirm(_this._translate.t('Are you sure deselect file?'))) {
          $file = _this._$(e.target).closest('[jq-attachments-selected-files-file]');
          $file.hide(_this._options.animationSpeed, function() {
            return _this.deSelectFile($file.attr('data-id'));
          });
        }
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-selected-files-file-remove]'
    });
  };


  /*
   * Bind events on instead Selector in field
   * @return void
   */

  Field.prototype._bindToSelector = function() {
    this._events.on(this._selector, 'change', (function(_this) {
      return function(e, filesId) {
        _this.setSelectedFiles(filesId);
        return _this._triggerChange();
      };
    })(this));
    return this._events.on(this._selector, 'delete', (function(_this) {
      return function(e, id) {
        return _this.deSelectFile(id);
      };
    })(this));
  };


  /*
   * Set input value for @_el
   * @return void
   */

  Field.prototype._setInputVal = function(filesId) {
    this._$el.val(filesId.join(this._options.valueDelimiter));
  };


  /*
   * Trigger change event
   * @return void
   */

  Field.prototype._triggerChange = function() {
    this._events.trigger(this, 'change', [this.getSelectedFiles()]);
  };

  return Field;

})();

module.exports = Field;


},{}],9:[function(require,module,exports){

/*
 * Class for attachments field
 * Alexander Konov
 */
'use strict';
var Selector;

Selector = (function() {

  /*
   * Constructor
   * @param DI di - dependency injection object
   * @param DOM el - an element which is attached to attachment field
   * @param {} options - object with options which configure Server object
   *  see description options in docs
   * @param DOM rootElement - element for storage rendered views
   */
  function Selector(di, rootElement, options, uid) {
    di.resolve(['$', 'collections.FilesCollection', 'server.Server', 'utils.Template', 'utils.Translate', 'events.Events'], ['collections.FilesCollection', 'server.Server', 'utils.Template', 'utils.Translate', 'events.Events']);
    this._$ = di.get('$');
    this._filesCollection = di.getInstance('collections.FilesCollection');
    this._server = di.getInstance('server.Server');
    this._template = di.getInstance('utils.Template');
    this._translate = di.getInstance('utils.Translate');
    this._events = di.getInstance('events.Events');
    this._$rootElement = this._$(rootElement);
    this._options = options;
    this._uid = uid;
    this._total = 0;
    this._offset = 0;
    this._selected = [];
    this._reverted = [];
  }


  /*
   * Open selector
   * @param string[] selected - id selected files
   * @return
   */

  Selector.prototype.open = function(selected) {
    var changed;
    if (!this._$view) {
      this._render();
    }
    changed = selected.concat(this._selected);
    this._selected = selected;
    if (this._total > 0) {
      this._renderFiles(0, null, null, changed);
      this._show();
    } else {
      this._show();
      this._loadFiles();
    }
  };


  /*
   * Render selector
   * @return void
   */

  Selector.prototype._render = function() {
    var html;
    if (this._$view !== void 0) {
      return;
    }
    html = this._template.render(this._options.view.selector, {
      accept: this._accept(),
      uid: this._uid
    });
    this._$view = this._$(html);
    this._$rootElement.append(this._$view);
    this._bind();
  };


  /*
   * Accept extensions (for render)
   * @return string
   */

  Selector.prototype._accept = function() {
    var extension, j, len, ref, result;
    if (!this._options.extensions) {
      return '';
    }
    result = null;
    ref = this._options.extensions;
    for (j = 0, len = ref.length; j < len; j++) {
      extension = ref[j];
      extension = extension.toLowerCase();
      if (result) {
        result += ', .' + extension;
      } else {
        result = '.' + extension;
      }
    }
    return result;
  };


  /*
   * Bind events for selector
   * @return void
   */

  Selector.prototype._bind = function() {
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        _this._cancel();
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-window-close]'
    });
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        var $file, selected, values;
        $file = _this._$(e.target).closest('[jq-attachments-file]');
        selected = $file.attr('data-selected') === 'true';
        if (!selected) {
          values = _this._getCurrentSelected();
          if (_this._options.maxSelected && _this._options.maxSelected <= values.length) {
            _this._options.dialog.alert(_this._translate.t('Sorry, you can select not more than {maxSelected} file(s).', {
              maxSelected: _this._options.maxSelected
            }));
            e.preventDefault();
            return false;
          }
        }
        _this._reverted.push($file.attr('data-id'));
        return $file.attr('data-selected', (selected ? 'false' : 'true'));
      };
    })(this), {
      selector: '[jq-attachments-file-select]'
    });
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        var $file;
        $file = _this._$(e.target).closest('[jq-attachments-file]');
        _this._deleteFile($file.attr('data-id'));
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-file-delete]'
    });
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        _this._apply();
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-apply]'
    });
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        _this._loadFiles();
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-files-more]'
    });
    this._events.on(this._$view, 'click', (function(_this) {
      return function(e) {
        _this._uploadFile();
        return e.preventDefault();
      };
    })(this), {
      selector: '[jq-attachments-upload-send]'
    });
  };


  /*
   * Check status of selected file
   * @param string id - file id
   * @return bool
   */

  Selector.prototype._isFileSelected = function(id) {
    return this._$.inArray(id, this._selected) !== -1;
  };


  /*
   * Render list files
   * @param int offset - starting offset for rendering in files collection
   * @param bool clear - switch clear rendering file
   * @param bool prepend - switch inserted rendered files to begin
   * @param string[] changed - changed files at which be re-rendered
   * @return bool
   */

  Selector.prototype._renderFiles = function(offset, clear, prepend, changed) {
    var $container, $oldFile, file, files, i, id, j, ref, ref1;
    changed = changed || [];
    files = this._filesCollection.getFiles();
    $container = this._$view.find('[jq-attachments-files]');
    if (clear) {
      $container.find('[jq-attachments-file]'.remove());
    }
    for (i = j = ref = offset, ref1 = files.length; ref <= ref1 ? j < ref1 : j > ref1; i = ref <= ref1 ? ++j : --j) {
      file = files[i];
      if (!file) {
        continue;
      }
      id = file.getField('id');
      $oldFile = $container.find('[jq-attachments-file][data-id="' + id + '"]');
      if ($oldFile.length > 0) {
        if (this._$.inArray(id, changed) === -1 && this._$.inArray(id, this._reverted) === -1) {
          continue;
        }
        $oldFile.replaceWith(this._getRenderedFile(file));
      } else {
        if (prepend) {
          $container.prepend(this._getRenderedFile(file));
        } else {
          $container.append(this._getRenderedFile(file));
        }
      }
    }
  };


  /*
   * Render file to html code
   * @param File file - file for rendering
   * @return string
   */

  Selector.prototype._getRenderedFile = function(file) {
    var html;
    html = this._template.render(this._options.view.selectorFile, {
      file: file,
      selected: this._isFileSelected(file.getField('id'))
    });
    return this._$(html);
  };


  /*
   * Apply actual status of select files
   * @return void
   */

  Selector.prototype._apply = function() {
    var change, id, j, len, values;
    this._reverted = [];
    values = this._getCurrentSelected();
    if (values.length !== this._selected.length) {
      change = true;
    } else {
      change = false;
      for (j = 0, len = values.length; j < len; j++) {
        id = values[j];
        if (!this._$.inArray(id, this._selected)) {
          change = true;
          break;
        }
      }
    }
    this._selected = values;
    if (change) {
      this._events.trigger(this, 'change', [values]);
    }
    this._hide();
  };


  /*
   * Close Selector without saving actual status
   * @return void
   */

  Selector.prototype._cancel = function() {
    this._hide();
  };


  /*
   * Show Selector
   * @return void
   */

  Selector.prototype._show = function() {
    this._$view.show(this._options.animationSpeed);
  };


  /*
   * Hide Selector
   * @return void
   */

  Selector.prototype._hide = function() {
    this._$view.hide(this._options.animationSpeed);
  };


  /*
   * Get current selected files
   * @return string[]
   */

  Selector.prototype._getCurrentSelected = function() {
    var $files, i, values;
    $files = this._$view.find('[jq-attachments-file][data-selected="true"]');
    values = (function() {
      var j, ref, results;
      results = [];
      for (i = j = 0, ref = $files.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        results.push(this._$($files[i]).attr('data-id'));
      }
      return results;
    }).call(this);
    return values;
  };


  /*
   * Load files to Selector from server
   * @param callable onSuccess - callback for success load files
   * @return void
   * @throw Error
   */

  Selector.prototype._loadFiles = function(onSuccess) {
    if (!this._options.url.list) {
      throw new Error('Url for list files is not set.');
    }
    this._startProgress();
    return this._server.list(this._options.url.list, {
      offset: this._offset,
      limit: this._options.listLimit,
      extension: this._options.extensions
    }, (function(_this) {
      return function(data) {
        _this._filesCollection.addFiles(data.files);
        _this._renderFiles(_this._offset);
        _this._offset += _this._options.listLimit;
        _this._total = data.total;
        if (_this._offset >= _this._total) {
          _this._$view.find('[jq-attachments-files-more]').hide();
        } else {
          _this._$view.find('[jq-attachments-files-more]').show();
        }
        if (onSuccess) {
          onSuccess(data);
        }
        return _this._stopProgress();
      };
    })(this), (function(_this) {
      return function(xhr, status) {
        _this._stopProgress();
        throw new Error("Can not load files. Error code " + status + ".");
      };
    })(this));
  };


  /*
   * Delete file from server
   * @param string id - id of deleted file
   * @return void
   * @throw Error
   */

  Selector.prototype._deleteFile = function(id) {
    if (!this._options.dialog.confirm(this._translate.t('Are you sure want to delete the file?'))) {
      return;
    }
    this._startProgress();
    return this._server["delete"](this._options.url["delete"], id, (function(_this) {
      return function() {
        var $file;
        _this._filesCollection.removeFile(id);
        if (_this._offset) {
          _this._offset--;
        }
        $file = _this._$view.find('[jq-attachments-file][data-id="' + id + '"]');
        _this._events.trigger(_this, 'delete', [id]);
        return $file.hide(_this._options.animationSpeed, function() {
          $file.remove();
          return _this._stopProgress();
        });
      };
    })(this), (function(_this) {
      return function(xhr, status) {
        _this._stopProgress();
        throw new Error("Can not delete file. Error code " + status + ".");
      };
    })(this));
  };


  /*
   * Upload files to server
   * @return void
   * @throw Error
   */

  Selector.prototype._uploadFile = function() {
    var $file, errors, file, files, formData, j, len, valid;
    $file = this._$view.find('[jq-attachments-upload]');
    if (!$file.get(0).files.length) {
      return;
    }
    formData = new FormData($file.closest('form').get(0));
    files = formData.getAll('file[]');
    errors = [];
    for (j = 0, len = files.length; j < len; j++) {
      file = files[j];
      valid = this._validateFile(file);
      if (valid !== true) {
        errors.push(this._translate.t('File "{name}" is not valid. Error: "{error}"', {
          name: file.name,
          error: valid
        }));
      }
    }
    if (errors.length > 0) {
      this._options.dialog.alert(errors.join("\n"));
      return;
    }
    this._startProgress();
    return this._server.upload(this._options.url.upload, formData, (function(_this) {
      return function(data) {
        var offset;
        $file.val('').trigger('change');
        offset = _this._filesCollection.length();
        _this._filesCollection.addFiles(data.files);
        _this._renderFiles(offset, false, true);
        return _this._stopProgress();
      };
    })(this), (function(_this) {
      return function(xhr, status) {
        _this._stopProgress();
        throw new Error("Can not upload files. Error code " + status + ".");
      };
    })(this));
  };


  /*
   * Validate file
   * @return true|sting - true if file is valid otherwise error message
   * @throw Error
   */

  Selector.prototype._validateFile = function(file) {
    var extension;
    if (this._options.maxUploadSize) {
      if (this._options.maxUploadSize < file.size) {
        return this._translate.t('File size should be <= {size} kb.', {
          size: Math.round(this._options.maxUploadSize / 1024, 2)
        });
      }
    }
    if (this._options.extensions) {
      extension = file.name.replace(/^.+\.([a-z0-9]+)$/, '$1');
      if (this._$.inArray(extension, this._options.extensions) === -1) {
        return this._translate.t('Invalid file extension. Allowed the following extensions: {extensions}.', {
          extensions: this._options.extensions.join(', ')
        });
      }
    }
    return true;
  };


  /*
   * Show progress line
   * @return void
   */

  Selector.prototype._startProgress = function() {
    if (this._$view) {
      return this._$view.find('[jq-attachments-progress]').show();
    }
  };


  /*
   * Hide progress line
   * @return void
   */

  Selector.prototype._stopProgress = function() {
    if (this._$view) {
      return this._$view.find('[jq-attachments-progress]').hide();
    }
  };

  return Selector;

})();

module.exports = Selector;


},{}],10:[function(require,module,exports){
(function (global){
'use strict';
var $, Attachments,
  slice = [].slice;

Attachments = require('./Attachments');

$ = (typeof window !== "undefined" ? window['$'] : typeof global !== "undefined" ? global['$'] : null);

$.fn.extend({
  attachments: function() {
    var args, integrate, option;
    option = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    integrate = (function(_this) {
      return function($this) {
        var data;
        data = $this.data('attachments');
        if (!data) {
          $this.data('attachments', (data = new Attachments($, _this, option, document.body)));
        }
        if (typeof option === 'string' && /^[a-zA-Z]+$/.test(option)) {
          return data[option].apply(data, args);
        }
        return _this;
      };
    })(this);
    if (this.length > 1) {
      return this.each(function() {
        return integrate($(this));
      });
    } else {
      return integrate(this);
    }
  }
});


}).call(this,typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"./Attachments":4}],11:[function(require,module,exports){

/*
 * File model
 * Alexander Konov
 */
'use strict';
var File,
  hasProp = {}.hasOwnProperty;

File = (function() {

  /*
   * Constructor
   * @param null|mixed{} data - object with data fields
   * @see File::setFields for more information
   */
  function File(data) {
    this._fields = {
      id: null,
      name: null,
      extension: null,
      size: null,
      url: null,
      preview_url: null,
      created_at: null,
      updated_at: null
    };
    if (data) {
      this.setFields(data);
    }
    return;
  }


  /*
   * Set few fields
   * @param null|mixed{} data - map object with data fields
   * Fields:
   *   int|string id - file ID
   *   string name - file name
   *   string extension - file extension
   *   int size - file size in bytes
   *   string preview_url - image preview url for this file
   *   int created_at - file created date (! save on server DB !)
   *   int updated_at - file updated date
   * Example
   *   file = new File {id:1, name: 'file'}
   */

  File.prototype.setFields = function(fields) {
    var name, value;
    for (name in fields) {
      if (!hasProp.call(fields, name)) continue;
      value = fields[name];
      this.setField(name, value);
    }
  };


  /*
   * Set field value
   * @param string name
   * @param mixed value
   * @see File::setFields for information about data types value
   */

  File.prototype.setField = function(name, value) {
    if (this._fields[name] !== void 0) {
      this._fields[name] = String(value);
    }
  };


  /*
   * Return all fields
   * @return mixed{} - object with data fields
   * @see File::setFields for information about data types fields
   */

  File.prototype.getFields = function() {
    var data, name, ref, value;
    if (Object.assign) {
      return Object.assign({}, this._fields);
    }
    data = {};
    ref = this._fields;
    for (name in ref) {
      if (!hasProp.call(ref, name)) continue;
      value = ref[name];
      data[name] = value;
    }
    return data;
  };


  /*
   * Return field value by name
   * @param string name - field name
   * @return mixed - field value
   * @see File::setFields for information about data type field
   */

  File.prototype.getField = function(fieldName) {
    if (this._fields[fieldName] !== null) {
      return this._fields[fieldName];
    } else {
      return null;
    }
  };

  return File;

})();

module.exports = File;


},{}],12:[function(require,module,exports){

/*
 * Class for make requests to server
 * Alexander Konov
 */
'use strict';
var Server;

Server = (function() {

  /*
   * Constructor
   * @param DI di - dependency injection object
   * @param {} options - object with options which configure Server object
   *  required
   *  options = {
   *    scheme: {
   *      file: fields for FileScheme,
   *      find: fields FindScheme,
   *      list: fields ListScheme,
   *      upload: fields UploadScheme,
   *    }
   *  }
   */
  function Server(di, options) {
    var fileScheme;
    di.resolve(['$', 'server.schemes.requests.Find', 'server.schemes.requests.List', 'server.schemes.requests.Upload', 'server.schemes.requests.Delete', 'server.schemes.responses.File', 'server.schemes.responses.Find', 'server.schemes.responses.List', 'server.schemes.responses.Upload']);
    this._$ = di.get('$');
    fileScheme = di.createObject('server.schemes.responses.File', [options.schemes.responses.file]);
    this._schemes = {
      requests: {
        find: di.createObject('server.schemes.requests.Find', [options.schemes.requests.find]),
        list: di.createObject('server.schemes.requests.List', [options.schemes.requests.list]),
        upload: di.createObject('server.schemes.requests.Upload', [options.schemes.requests.upload]),
        "delete": di.createObject('server.schemes.requests.Delete', [options.schemes.requests["delete"]])
      },
      responses: {
        file: fileScheme,
        find: di.createObject('server.schemes.responses.Find', [
          options.schemes.responses.find, {
            files: fileScheme
          }
        ]),
        list: di.createObject('server.schemes.responses.List', [
          options.schemes.responses.list, {
            files: fileScheme
          }
        ]),
        upload: di.createObject('server.schemes.responses.Upload', [
          options.schemes.responses.upload, {
            files: fileScheme
          }
        ])
      }
    };
  }


  /*
   * Send request for find files
   * @param string url - request url
   * @param mixed[] data - request data (sending on server how GET parameters)
   * @param callable onSuccess - callback which invoke done request is success
   *    have following parameters:
   *      mixed{} result - data from server as json object
   * @param callable onError - callback which invoke done request is fail
   *    have following parameters:
   *      jqXHR jqXHR - object jQuery XMLHttpRequest
   *      string textStatus - textStatus of error
   */

  Server.prototype.find = function(url, data, onSuccess, onError) {
    return this._$.ajax({
      url: url,
      type: 'GET',
      dataType: 'json',
      data: this._schemes.requests.find.toScheme(data)
    }).done((function(_this) {
      return function(result) {
        data = _this._schemes.responses.find.toData(result);
        if (onSuccess) {
          return onSuccess(data);
        }
      };
    })(this)).fail((function(_this) {
      return function(jqXHR, textStatus) {
        if (onError) {
          return onError(jqXHR, textStatus);
        }
      };
    })(this));
  };


  /*
   * Send request for list files
   * @param string url - request url
   * @param mixed[] data - request data (sending on server how GET parameters)
   * @param callable onSuccess - callback which invoke done request is success
   *    have following parameters:
   *      mixed{} result - data from server as json object
   * @param callable onError - callback which invoke done request is fail
   *    have following parameters:
   *      jqXHR jqXHR - object jQuery XMLHttpRequest
   *      string textStatus - textStatus of error
   */

  Server.prototype.list = function(url, params, onSuccess, onError) {
    return this._$.ajax({
      url: url,
      type: 'GET',
      dataType: 'json',
      data: this._schemes.requests.list.toScheme(params)
    }).done((function(_this) {
      return function(data) {
        data = _this._schemes.responses.list.toData(data);
        if (onSuccess) {
          return onSuccess(data);
        }
      };
    })(this)).fail((function(_this) {
      return function(jqXHR, textStatus) {
        if (onError) {
          return onError(jqXHR, textStatus);
        }
      };
    })(this));
  };


  /*
   * Upload files on server
   * @param string url - request url
   * @param FormData formData - object FormData which contain files for uploading
   * @param callable onSuccess - callback which invoke done request is success
   *    have following parameters:
   *      mixed{} result - data from server as json object
   * @param callable onError - callback which invoke done request is fail
   *    have following parameters:
   *      jqXHR jqXHR - object jQuery XMLHttpRequest
   *      string textStatus - textStatus of error
   */

  Server.prototype.upload = function(url, formData, onSuccess, onError) {
    var data, file, files, i, len, paramName;
    data = new FormData();
    paramName = this._schemes.requests.upload.getSchemeFieldName('file');
    files = formData.getAll('file[]');
    for (i = 0, len = files.length; i < len; i++) {
      file = files[i];
      data.append(paramName + '[]', file);
    }
    return this._$.ajax({
      url: url,
      type: 'POST',
      contentType: false,
      processData: false,
      dataType: 'json',
      data: data
    }).done((function(_this) {
      return function(data) {
        data = _this._schemes.responses.upload.toData(data);
        if (onSuccess) {
          return onSuccess(data);
        }
      };
    })(this)).fail((function(_this) {
      return function(jqXHR, textStatus) {
        if (onError) {
          return onError(jqXHR, textStatus);
        }
      };
    })(this));
  };


  /*
   * Send request for delete file
   * @param string url - request url
   * @param mixed[] data - request data (sending on server how GET parameters)
   * @param callable onSuccess - callback which invoke done request is success
   *    have following parameters:
   *      no params
   * @param callable onError - callback which invoke done request is fail
   *    have following parameters:
   *      jqXHR jqXHR - object jQuery XMLHttpRequest
   *      string textStatus - textStatus of error
   */

  Server.prototype["delete"] = function(url, id, onSuccess, onError) {
    return this._$.ajax({
      url: url,
      type: 'GET',
      dataType: 'json',
      data: this._schemes.requests["delete"].toScheme({
        id: id
      })
    }).done((function(_this) {
      return function() {
        if (onSuccess) {
          return onSuccess();
        }
      };
    })(this)).fail((function(_this) {
      return function(jqXHR, textStatus) {
        if (onError) {
          return onError(jqXHR, textStatus);
        }
      };
    })(this));
  };

  return Server;

})();

module.exports = Server;


},{}],13:[function(require,module,exports){

/*
 * Abstract scheme to associate fields from server with fields from model
 * Alexander Konov
 */
'use strict';
var AbstractScheme,
  hasProp = {}.hasOwnProperty;

AbstractScheme = (function() {
  AbstractScheme.FORMAT_TYPE_DATA = 'data';

  AbstractScheme.FORMAT_TYPE_SCHEME = 'scheme';

  AbstractScheme.DEPENDENCY_TYPE_ARRAY = 'array';

  AbstractScheme.DEPENDENCY_TYPE_OBJECT = 'object';


  /*
   * Constructor
   * @param string{} fields - object with fields and aliases from server
   *   format: {fieldName:serverAliasName, }
   *   example: {id: 'server_model_id', name: 'full_name', size: 'count'}
   * @param AbstractScheme{} dependencies - objects with dependencies
   *   format: {dependencyName: dependencyObject, }
   */

  function AbstractScheme(fields, dependencies) {
    this._fields = fields;
    this._dependencies = dependencies ? dependencies : {};
    if (!this._checkFields()) {
      throw new Error('Incorrect fields.');
    }
    if (!this._checkDependencies()) {
      throw new Error('Incorrect dependencies.');
    }
  }


  /*
   * Abstract method
   * Return array with required fields
   * @return string[]
   */

  AbstractScheme.prototype.fields = function() {
    return [];
  };


  /*
   * Abstract method
   * Return array with required dependencies
   * @return {fieldName:class, ...} || {fieldName: ['type', class], ...}
   */

  AbstractScheme.prototype.dependencies = function() {
    return {};
  };


  /*
   * Associate fields from server to fields from model
   * @param mixed{} schemeFields - scheme data
   *   example: toData({user_id: 1, user_name: 'mr. Smith'}) returned {id: 1, name: 'mt. Smith'}
   *            where this.fields() == ['id', 'name'] && this._fields = {id:'user_id', name: 'user_name'} (see constructor)
   */

  AbstractScheme.prototype.toData = function(schemeFields) {
    var dataKey, ref, result, schemeKey, value;
    result = {};
    ref = this._fields;
    for (dataKey in ref) {
      if (!hasProp.call(ref, dataKey)) continue;
      schemeKey = ref[dataKey];
      value = schemeFields[schemeKey];
      if (value === void 0) {
        continue;
      }
      result[dataKey] = this._formatValue(this.constructor.FORMAT_TYPE_DATA, dataKey, value);
    }
    return result;
  };


  /*
   * Associate fields from model to fields from server
   * @param mixed{} dataFields - local data
   *   Example:
   *            toScheme({id: 1, name: 'mt. Smith'}) returned {user_id: 1, user_name: 'mr. Smith'}
   *            where this.fields() == ['id', 'name'] && this._fields = {id:'user_id', name: 'user_name'} (see constructor)
   */

  AbstractScheme.prototype.toScheme = function(dataFields) {
    var dataKey, ref, result, schemeKey, value;
    result = {};
    ref = this._fields;
    for (dataKey in ref) {
      if (!hasProp.call(ref, dataKey)) continue;
      schemeKey = ref[dataKey];
      value = dataFields[dataKey];
      if (value === void 0) {
        continue;
      }
      result[schemeKey] = this._formatValue(this.constructor.FORMAT_TYPE_SCHEME, dataKey, value);
    }
    return result;
  };


  /*
   * Get scheme field name by data field name
   * @params string field - data field name
   * @return string|undefined
   */

  AbstractScheme.prototype.getSchemeFieldName = function(field) {
    if (this._fields[field] === void 0) {
      return void 0;
    }
    return this._fields[field];
  };


  /*
   * Check on required fields
   * @return bool
   */

  AbstractScheme.prototype._checkFields = function() {
    var field, fields, i, len, result;
    result = true;
    fields = this.fields();
    for (i = 0, len = fields.length; i < len; i++) {
      field = fields[i];
      if (this._fields[field] === void 0) {
        result = false;
        break;
      }
    }
    return result;
  };


  /*
   * Check on required dependencies
   * @return bool
   */

  AbstractScheme.prototype._checkDependencies = function() {
    var dependencies, dependency, field, value;
    dependencies = this.dependencies();
    for (field in dependencies) {
      if (!hasProp.call(dependencies, field)) continue;
      dependency = dependencies[field];
      value = this._dependencies[field];
      if (!(dependency instanceof Array)) {
        if (!(value instanceof dependency)) {
          return false;
        }
      } else {
        dependency = dependency[1];
        if (!(value instanceof dependency)) {
          return false;
        }
      }
    }
    return true;
  };


  /*
   * Return field value for this scheme
   * @param string type - type of format (see const FORMAT_TYPE_*)
   * @param string dataKey - key field for local model
   * @param mixed value - input value for associating
   * @return mixed
   */

  AbstractScheme.prototype._formatValue = function(type, dataKey, value) {
    var dependency, dependencyConfig, dependencyType, i, len, result, valueItem, valueKey;
    dependency = this._dependencies[dataKey];
    if (!dependency) {
      return value;
    }
    dependencyConfig = this.dependencies()[dataKey];
    if (!(dependencyConfig instanceof Array)) {
      return this._dependencyValue(type, value, dependency);
    }
    dependencyType = dependencyConfig[0];
    if (dependencyType === this.constructor.DEPENDENCY_TYPE_ARRAY) {
      if (!(value instanceof Array)) {
        return void 0;
      }
      result = [];
      for (i = 0, len = value.length; i < len; i++) {
        valueItem = value[i];
        result.push(this._dependencyValue(type, valueItem, dependency));
      }
      return result;
    }
    if (dependencyType === this.constructor.DEPENDENCY_TYPE_OBJECT) {
      result = {};
      for (valueKey in value) {
        if (!hasProp.call(value, valueKey)) continue;
        result[valueKey] = this._dependencyValue(type, value[valueKey], dependency);
      }
      return result;
    }
    return null;
  };


  /*
   * Return dependency value according to type
   * @param string type - type of format (see const FORMAT_TYPE_*)
   * @param mixed value - input value for associating
   * @param AbstractScheme dependency - dependency object for this value
   * @return mixed
   */

  AbstractScheme.prototype._dependencyValue = function(type, value, dependency) {
    if (type === this.constructor.FORMAT_TYPE_DATA) {
      return dependency.toData(value);
    }
    if (type === this.constructor.FORMAT_TYPE_SCHEME) {
      return dependency.toScheme(value);
    }
    return void 0;
  };

  return AbstractScheme;

})();

module.exports = AbstractScheme;


},{}],14:[function(require,module,exports){

/*
 * Delete request scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, Delete,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

Delete = (function(superClass) {
  extend(Delete, superClass);

  function Delete() {
    return Delete.__super__.constructor.apply(this, arguments);
  }

  Delete.prototype.fields = function() {
    return ['id'];
  };

  return Delete;

})(AbstractScheme);

module.exports = Delete;


},{"../AbstractScheme":13}],15:[function(require,module,exports){

/*
 * Find request scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, Find,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

Find = (function(superClass) {
  extend(Find, superClass);

  function Find() {
    return Find.__super__.constructor.apply(this, arguments);
  }

  Find.prototype.fields = function() {
    return ['id', 'name', 'extension'];
  };

  return Find;

})(AbstractScheme);

module.exports = Find;


},{"../AbstractScheme":13}],16:[function(require,module,exports){

/*
 * List request scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, List,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

List = (function(superClass) {
  extend(List, superClass);

  function List() {
    return List.__super__.constructor.apply(this, arguments);
  }

  List.prototype.fields = function() {
    return ['id', 'name', 'extension', 'offset', 'limit'];
  };

  return List;

})(AbstractScheme);

module.exports = List;


},{"../AbstractScheme":13}],17:[function(require,module,exports){

/*
 * Upload request scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, Upload,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

Upload = (function(superClass) {
  extend(Upload, superClass);

  function Upload() {
    return Upload.__super__.constructor.apply(this, arguments);
  }

  Upload.prototype.fields = function() {
    return ['file'];
  };

  return Upload;

})(AbstractScheme);

module.exports = Upload;


},{"../AbstractScheme":13}],18:[function(require,module,exports){

/*
 * File response scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, File,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

File = (function(superClass) {
  extend(File, superClass);

  function File() {
    return File.__super__.constructor.apply(this, arguments);
  }

  File.prototype.fields = function() {
    return ['id', 'name', 'extension', 'size', 'url', 'preview_url', 'created_at', 'updated_at'];
  };

  return File;

})(AbstractScheme);

module.exports = File;


},{"../AbstractScheme":13}],19:[function(require,module,exports){

/*
 * Find response scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, File, Find,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

File = require('./File');

Find = (function(superClass) {
  extend(Find, superClass);

  function Find() {
    return Find.__super__.constructor.apply(this, arguments);
  }

  Find.prototype.fields = function() {
    return ['files'];
  };

  Find.prototype.dependencies = function() {
    return {
      files: [AbstractScheme.DEPENDENCY_TYPE_ARRAY, File]
    };
  };

  return Find;

})(AbstractScheme);

module.exports = Find;


},{"../AbstractScheme":13,"./File":18}],20:[function(require,module,exports){

/*
 * List response scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, File, List,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

File = require('./File');

List = (function(superClass) {
  extend(List, superClass);

  function List() {
    return List.__super__.constructor.apply(this, arguments);
  }

  List.prototype.fields = function() {
    return ['total', 'files'];
  };

  List.prototype.dependencies = function() {
    return {
      files: [AbstractScheme.DEPENDENCY_TYPE_ARRAY, File]
    };
  };

  return List;

})(AbstractScheme);

module.exports = List;


},{"../AbstractScheme":13,"./File":18}],21:[function(require,module,exports){

/*
 * Upload response scheme
 * Alexander Konov
 */
'use strict';
var AbstractScheme, File, Upload,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AbstractScheme = require('../AbstractScheme');

File = require('./File');

Upload = (function(superClass) {
  extend(Upload, superClass);

  function Upload() {
    return Upload.__super__.constructor.apply(this, arguments);
  }

  Upload.prototype.fields = function() {
    return ['files'];
  };

  Upload.prototype.dependencies = function() {
    return {
      files: [AbstractScheme.DEPENDENCY_TYPE_ARRAY, File]
    };
  };

  return Upload;

})(AbstractScheme);

module.exports = Upload;


},{"../AbstractScheme":13,"./File":18}],22:[function(require,module,exports){

/*
 * DataMap util
 * Alexander Konov
 */
'use strict';
var DataMap,
  hasProp = {}.hasOwnProperty;

DataMap = (function() {

  /*
   * Constructor
   * @param null|mixed{}|mixed[] items - items for map
   * @see DataMap::add for more information
   */
  function DataMap(items) {
    this._items = {};
    this._order = [];
    if (items) {
      this.addItems(items);
    }
    return;
  }


  /*
   * Checking of existence item by key in map
   * @param string|int key - key of item
   * @return bool
   */

  DataMap.prototype.has = function(key) {
    return this._items[key] !== void 0;
  };


  /*
   * Add few item to map
   * @param null|mixed{}|mixed[] items - items for map
   * @see DataMap::add for more information
   */

  DataMap.prototype.addItems = function(items) {
    var key;
    for (key in items) {
      if (!hasProp.call(items, key)) continue;
      this.add(key, items[key]);
    }
  };


  /*
   * Add item to map
   * @param string|int key - item key
   * @param mixed - item value
   */

  DataMap.prototype.add = function(key, value) {
    if (this.has(key)) {
      this._items[key] = value;
    } else {
      this._items[key] = value;
      this._order.push(key.toString());
    }
  };


  /*
   * Get item value by key
   * @param string|int key - item key
   * @return mixed|null
   */

  DataMap.prototype.get = function(key) {
    if (this.has(key)) {
      return this._items[key];
    } else {
      return null;
    }
  };


  /*
   * Remove item in map by key
   * @param string|int key - item key
   */

  DataMap.prototype.remove = function(key) {
    var orderIndex;
    delete this._items[key];
    orderIndex = this._order.indexOf(key.toString());
    if (orderIndex !== -1) {
      this._order.splice(orderIndex, 1);
    }
  };


  /*
   * Call function for each item in map
   * @param callable fn(key, value) - function calls for each item
   */

  DataMap.prototype.each = function(fn) {
    var i, key, len, ref;
    ref = this._order;
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      fn(key, this.get(key));
    }
  };


  /*
   * Return array with all added items to map
   * Items sorted by order adding to map
   * @return {key: key, value: value}[]
   */

  DataMap.prototype.all = function() {
    var i, key, len, ref, result;
    result = [];
    ref = this._order;
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      result.push({
        key: key,
        value: this.get(key)
      });
    }
    return result;
  };


  /*
   * Return array with all added values to map
   * Items sorted by order adding to map
   * @return mixed[]
   */

  DataMap.prototype.toArray = function() {
    var i, key, len, ref, result;
    result = [];
    ref = this._order;
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      result.push(this.get(key));
    }
    return result;
  };


  /*
   * Remove all items in map
   */

  DataMap.prototype.clear = function() {
    this._items = {};
    this._order = [];
  };


  /*
   * Number of items in map
   * @return int
   */

  DataMap.prototype.length = function() {
    return this._order.length;
  };

  return DataMap;

})();

module.exports = DataMap;


},{}],23:[function(require,module,exports){

/*
 * Default dialogs
 * Alexander Konov
 */
'use strict';
var Dialog;

Dialog = (function() {
  function Dialog() {}


  /*
   * Alert message
   * @param string message - message for alert
   */

  Dialog.alert = function(message) {
    alert(message);
  };


  /*
   * Confirm dialog
   * @param string message - message for confirm
   * @return bool
   */

  Dialog.confirm = function(message) {
    return confirm(message);
  };

  return Dialog;

})();

module.exports = Dialog;


},{}],24:[function(require,module,exports){

/*
 * Template
 * Alexander Konov
 */
'use strict';
var Template;

Template = (function() {

  /*
   * Constructor
   * @param DI di - dependencies object
   */
  function Template(di) {
    di.resolve(['lodash.template', 'utils.Translate'], ['utils.Translate']);
    this._template = di.get('lodash.template');
    this._translate = di.getInstance('utils.Translate');
  }


  /*
   * Render view to html
   * @param string source - view source for rendering
   * @param mixed{} vars - vars for inserting to view
   * @return string
   * For syntax detail see https://lodash.com/docs/4.17.4#template
   */

  Template.prototype.render = function(source, vars) {
    var render;
    if (!vars) {
      vars = {};
    }
    vars.translate = this._translate;
    render = this._template(source);
    return render(vars);
  };

  return Template;

})();

module.exports = Template;


},{}],25:[function(require,module,exports){

/*
 * Translate
 * Alexander Konov
 */
'use strict';

/*
 * Escape string for regular expression
 * @param string str - non-escaped string
 * @return string
 */
var Translate, escape,
  hasProp = {}.hasOwnProperty;

escape = function(str) {
  return str.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
};

Translate = (function() {

  /*
   * Constructor
   * @param string{} phrases - object with translate dictionary,
   * where key - phrase in its original language, value - translated phrase
   * Example:
   *   {
   *       'Hello, {name}!': 'Привет, {name}!',
   *       ...
   *   }
   */
  function Translate(phrases) {
    this._phrases = phrases;
  }


  /*
   * Translate phrase with params
   * @param string phrase - phrase in its original language
   * @param string{} params - object with params for replace, where key should be consist in phrase how {paramKey}
   * @return string
   * if phrase not found in dictionary, when only replaced params.
   */

  Translate.prototype.t = function(phrase, params) {
    var translate;
    translate = this._phrases[phrase] ? this._phrases[phrase] : phrase;
    if (params) {
      translate = this._replaceParams(translate, params);
    }
    return translate;
  };


  /*
   * Replace params in phrase to params value
   * @param string phrase - original phrase
   * @param string{} params - object with params for replace
   * @return string
   */

  Translate.prototype._replaceParams = function(phrase, params) {
    var expr, key, value;
    for (key in params) {
      if (!hasProp.call(params, key)) continue;
      value = params[key];
      expr = new RegExp(escape('{' + key + '}'), 'g');
      phrase = phrase.replace(expr, value);
    }
    return phrase;
  };

  return Translate;

})();

module.exports = Translate;


},{}],26:[function(require,module,exports){

/*
 * Function for merge two associate objects
 * Alexander Konov
 */
'use strict';

/*
 * Merge two associate objects
 * @param {} master - master object, used as base
 * @param {} slave - slave object, used as addition
 * @return {}
 */
var merge,
  hasProp = {}.hasOwnProperty;

merge = function(master, slave) {
  var key, result, value;
  result = {};
  for (key in master) {
    if (!hasProp.call(master, key)) continue;
    value = master[key];
    if ((typeof value) === 'object' && slave[key] !== void 0) {
      if (value !== null) {
        result[key] = merge(value, slave[key]);
      } else {
        result[key] = slave[key];
      }
    } else if (slave[key] !== void 0) {
      result[key] = slave[key];
    } else {
      result[key] = value;
    }
  }
  return result;
};

module.exports = merge;


},{}],27:[function(require,module,exports){

/*
 * Function for generate unique string
 * Alexander Konov
 */
'use strict';
var history, uniqueID;

history = {};


/*
 * Generate unique ID
 * @return string
 */

uniqueID = function() {
  var uid;
  uid = 'uid' + Math.random().toString().replace('0.', '');
  if (history[uid]) {
    uid = uniqueID();
  } else {
    history[uid] = true;
  }
  return uid;
};

module.exports = uniqueID;


},{}],28:[function(require,module,exports){
'use strict';
var template;

template = " <div class=\"jq-attachments-selected <%= (files.length == 0) ? 'empty' : '' %>\">\n   <div class=\"jq-attachments-selected-empty\"><%= translate.t('No attached files.')%></div>\n   <ul class=\"jq-attachments-selected-files\" jq-attachments-selected-files>\n   <% for (var i = 0, l = files.length; i<l; i++) {%>\n       <% file = files[i]%>\n       <li class=\"jq-attachments-selected-file\" data-id=\"<%= file.getField('id')%>\" jq-attachments-selected-files-file>\n           <a class=\"jq-attachments-selected-file-load\" href=\"<%= file.getField('url')%>\" target=\"_blank\"><%= file.getField('name')%></a>\n           <span class=\"jq-attachments-selected-file-remove\" jq-attachments-selected-files-file-remove>+</span>\n       </li>\n   <%}%>\n   </ul>\n   <button class=\"jq-attachments-add\" jq-attachments-add><%= translate.t('Add files')%></button>\n</div>";

module.exports = template;


},{}],29:[function(require,module,exports){
'use strict';
var template;

template = "<section uid=\"<%= uid%>\" class=\"jq-attachments-window\" jq-attachments-window>\n    <div class=\"jq-attachments-window-content\">\n        <header class=\"jq-attachments-window-content-header\">\n            <form enctype=\"multipart/form-data\">\n                <div class=\"jq-attachments-upload\">\n                  <label>\n                    <input type=\"file\" name=\"file[]\" jq-attachments-upload multiple accept=\"<%= accept%>\"/>\n                    <span data-role=\"upload-text\"><%= translate.t('Select files')%></span>\n                  </label>\n                </div>\n                <input type=\"submit\" class=\"jq-attachments-upload-send\" value=\"upload\" jq-attachments-upload-send disabled/>\n            </form>\n            <div class=\"jq-attachments-progress\" title=\"<%= translate.t('Wait...')%>\" jq-attachments-progress>\n                <div></div>\n            </div>\n            <span class=\"jq-attachments-window-close\" jq-attachments-window-close>+</span>\n        </header>\n        <main class=\"jq-attachments-window-content-main\">\n            <div class=\"jq-attachments-files\">\n              <div jq-attachments-files>\n              </div>\n              <input type=\"submit\" value=\"<%= translate.t('Load more files')%>\" class=\"jq-attachments-files-more\" jq-attachments-files-more/>\n            </div>\n        </main>\n        <footer class=\"jq-attachments-window-content-footer\">\n            <input type=\"submit\" value=\"<%= translate.t('Save')%>\" class=\"jq-attachments-apply\" jq-attachments-apply/>\n            <input type=\"submit\" value=\"<%= translate.t('Cancel')%>\" class=\"jq-attachments-cancel\" jq-attachments-window-close/>\n        </footer>\n    </div>\n    <div class=\"jq-attachments-window-bg\" jq-attachments-window-close></div>\n</section>\n\n<%\n//script for  UI logic (custom upload form)\nvar interval = null;\nvar renderUpload = function ()\n {\n   var fieldFile = document.querySelector('[uid=\"' + uid + '\"] [jq-attachments-upload]');\n   if (fieldFile) {\n     clearInterval(interval);\n     var uploadSendButton = document.querySelector('[uid=\"' + uid + '\"] [jq-attachments-upload-send]');\n     var uploadText = document.querySelector('[uid=\"' + uid + '\"] [data-role=\"upload-text\"]');\n     fieldFile.onchange = function () {\n        var countFiles = this.files.length;\n        var message;\n        if (countFiles) {\n          message = translate.t('Selected {countFiles} files', {countFiles: countFiles});\n        } else {\n          message = translate.t('Select files');\n        }\n        uploadText.innerHTML = message;\n        uploadSendButton.disabled = !countFiles;\n     };\n   }\n};\n\ninterval = setInterval(renderUpload, 100);\n%>";

module.exports = template;


},{}],30:[function(require,module,exports){
'use strict';
var template;

template = "<div class=\"jq-attachments-file\" data-id=\"<%= file.getField('id')%>\" data-selected=\"<%= (selected ? 'true' : 'false')%>\" jq-attachments-file>\n    <input type=\"checkbox\" jq-attachments-file-select<%= (selected ? ' checked' : '')%>/>\n    <span class=\"jq-attachments-file-delete\" jq-attachments-file-delete></span>\n    <img src=\"<%= file.getField('preview_url')%>\" alt=\"<%= file.getField('name')%>\"/>\n    <a href=\"<%= file.getField('url')%>\" target=\"_blank\" title=\"<%= file.getField('name')%>\" class=\"jq-attachments-file-link\"><%= file.getField('name')%></a>\n</div>";

module.exports = template;


},{}]},{},[10])